<template src="./template.html"/>
<style scoped src="./stylesheet.scss" lang="scss"/>

<script>
    import axios from 'axios';
    import {store} from "@/store/store";
    import VueUploadMultipleImage from 'vue-upload-multiple-image';
    import ShopForm from "../../../../components/ShopForm/ShopForm";

    // Importing validators
    import { email} from 'vuelidate/lib/validators'

    export default {
        name: "ShopCreation",
        components: {
            VueUploadMultipleImage,
            ShopForm
        },
        data() {
            return {
                // TO CREATE THE SHOP
                email: null,
                shop: {
                    name: null,
                    description: null,
                    deliveryDetails: null,
                    deliveryConditions: null,
                    contacts: [], /* { "name": "string", "contactTypeId": 0} */
                    paymentTypesId: [],
                    categoryId: null,
                    city: 'Desenzano del Garda',
                    address: null,
                    primaryImageBase64: null,
                    imagesBase64: [],
                    contactNote: null,   //  in old version: notes,
                    websiteLink: null
                },

                shopFormState: true,

                tempImages: []
            }
        },
        validations: {
            email: {
                email: email
            }
        },
        computed: {
            buttonDisabled() {
                return this.$v.$invalid || this.shopFormState || this.isButtonDisabled;
            }
        },
        methods: {
            createShop() {
                this.isButtonDisabled = true;
                this.shop.primaryImageBase64 = null;
                this.shop.imagesBase64 = [];

                let imagesToSend = this.tempImages.slice();// Copy the array to a new one to edit it
                if(imagesToSend.length) {
                    this.shop.primaryImageBase64 = imagesToSend[0].path;
                    imagesToSend.splice(0, 1);
                    imagesToSend.forEach((image) => {
                        this.shop.imagesBase64.push(image.path);
                    });
                }

                // È possibile effettuare la richiesta
                axios({
                    method: "POST",
                    "url": "/account/admin/register",
                    headers: {
                        Authorization: 'Bearer ' + store.getters.token
                    },
                    data: {
                        "account": {
                            "email": this.email
                        },
                        "store": this.shop
                    }
                }).then(() => {
                    this.$bvModal.msgBoxOk('Il negozio è stato creato correttamente.', {
                        title: 'Ottimo!',
                        okVariant: 'success',
                        headerClass: 'p-2 border-bottom-0',
                        footerClass: 'p-2 border-top-0',
                        centered: true
                    }).then(() => {
                        this.$router.push('/dashboard/lista-negozi');
                    });
                    this.clearForm();
                }).catch((error) => {
                    this.$bvModal.msgBoxOk(error.response.data.error, {
                        title: 'Attenzione',
                        okVariant: 'primary'
                    }).then(() => {
                        this.isButtonDisabled = false;
                    });
                });
            },
            uploadImageSuccess(formData, index, fileList) {
                this.tempImages = fileList;
            },
            beforeRemove(index, done, fileList) {
                console.log('index', index, fileList);
                let r = confirm("remove image");
                if (r) {
                    done()
                }
            },
            editImage(formData, index, fileList) {
                console.log('edit data', formData, index, fileList)
            },
            clearForm() {
                this.shop.name = null;
                this.shop.description = null;
                this.shop.deliveryDetails = null;
                this.shop.deliveryConditions = null;
                this.shop.contacts = [];
                this.shop.paymentTypesId = [];
                this.shop.categoryId = null;
                this.shop.city = 'Desenzano del Garda';
                this.shop.address = null;
                this.shop.primaryImageBase64 = null;
                this.shop.imagesBase64 = [];
                this.shop.contactNote = null;

                this.tempImages = [];
                this.error = null;
            },
            userInput(value) {
                this.shopFormState = value;
            }
        }
    }
</script>
